/*
 * NicoScreen, version: 0.1 (2011-07-11)
 *
 *
 * For usage and examples, visit:
 * http://nicoscreen.r9game.com
 *
 * Licensed under the MIT:
 * http://www.opensource.org/licenses/mit-license.php
 *
 * Copyright (c) 2011, Shikemoku.MK (shikemoku.mk -[at]- gmail [*dot*] com)
 */
/*
 * Modified by Nico2AreX̒̐l
 */

var nico_w = 640;
var nico_h = 360;
var comment_max_row_temp = 0;

function nicoscreenobj(o) {
  var f = nicoscreenobj.f, i, len, n, prop;
  f.prototype = o;
  n = new f;
  for (i=1, len=arguments.length; i<len; ++i)
    for (prop in arguments[i])
      n[prop] = arguments[i][prop];
  return n;
}
nicoscreenobj.f = function(){};

var r9 = {};
r9.NicoScreen = {
	
	
	
	env : {
		
		color:"white",
		interval:500,
		speed:6500,
		font_size:"24px",
		loop:true,
		
		height:"",
		width:""
		
	},
	
	top_pos:20,
	draw_index:0,
	comments:[],
	
	set:function(o){
		
		this.comments = o.comments;
		
		if(o.base.color){
			this.env.color = o.base.color;
		}
		
		if(o.base.loop){
			this.env.loop = o.base.loop;
		}
		
		if(o.base.interval){
			
			switch(o.base.interval){
				
			case "fast":
				this.env.interval=3000;
				break;
			case "slow":
				this.env.interval=9500;
				break;
				
			}
			
		}
		
		if(o.base.font_size){
			this.env.font_size = o.base.font_size;
		}
		
		if(o.base.speed){
		
			switch(o.base.speed){
			
			case "fast":
				this.env.speed=4000;
				break;
			case "slow":
				this.env.speed=10000;
				break;
			case "normal":
				this.env.speed=6500;
				break;
			default:
				this.env.speed=parseInt(o.base.speed);
				break;
				
			}
		
		}
		
	},
	
	start : function(){
	
    	//F`FbN{bNX
    	var c_nico_color = getCookie("nico_color");
    	if (isNaN(c_nico_color)) {
	    	if (comment_color_on ==1) {
    			 document.getElementById("nico_color").checked = true;
    		} else {
    			 document.getElementById("nico_color").checked = false;
    		}
    	} else {
	    	if (c_nico_color ==1) {
    			 document.getElementById("nico_color").checked = true;
    		} else {
    			 document.getElementById("nico_color").checked = false;
    		}
    	}
    	//tC`FbN{bNX
    	if (comment_max_row > 0) {
	    	comment_max_row_temp = comment_max_row;
    	} else {
	    	comment_max_row_temp = 3;
    	}
    	var c_nico_full = getCookie("nico_full");
    	if (isNaN(c_nico_full)) {
	    	if (comment_max_row == 0) {
    			 document.getElementById("nico_full").checked = true;
	    	} else {
    			 document.getElementById("nico_full").checked = false;
    		}
    	} else {
	    	if (c_nico_full ==1) {
    			 document.getElementById("nico_full").checked = true;
    		} else {
    			 document.getElementById("nico_full").checked = false;
    		}
    	}
    	//\E\
    	var c_nico_on = getCookie("nico_on");
    	if (isNaN(c_nico_on)) {
    	} else {
	    	if (c_nico_on ==1) {
    			 document.getElementById("nico_on").checked = true;
    		} else {
    			 document.getElementById("nico_on").checked = false;
    		}
    	}

		var elm = $("#nicoscreen");
		this.elm = elm;
		this.elm.css("position", "relative");
		this.elm.css("border", "solid 1px gray");
		this.elm.css("overflow", "hidden");
		this.elm.bind("selectstart",function(){return false;});
		this.elm.bind("mousedown",function(){return false;});
		
		
		this.env.width = ""+elm.css("width");
		this.env.height = ""+elm.css("height");
		
		nico_w = this.env.width;
		nico_h = this.env.height;
		
		this.env.width = this.env.width.replace("px","");
		this.env.height = this.env.height.replace("px","");
		
		//Kv
		//var inid = setInterval("nicoscreen.draw(null)", this.env.interval);
		
	},
	
	draw: function(str){
	
		var n = nicoscreen;
		
		var i = n.draw_index;
		var comment_str =  "";
		
		if(str){
			comment_str = str;
			i=parseInt((new Date)/1000);
		}else{
		
			if (n.draw_index >= n.comments.length) {
				if(n.env.loop) n.draw_index = 0;
				return false;
			}
			comment_str = n.comments[i];
			n.draw_index++;
		}
		
		var comment_width = parseInt(parseInt(n.env.font_size) * comment_str.length * 1.0); //̒𐄒
		var width_random = parseInt(parseInt(nico_w / (n.env.speed / 1000)) * ((Math.floor(Math.random() * 100)) / 100)); //W
		var start_left = nico_w + width_random;
		var end_left = parseInt(comment_width * -1.1) - parseInt(parseInt(nico_w / (n.env.speed / 1000)) - width_random); //ŏIʒu@Ô1ɂ
		var speed_temp = parseInt(n.env.speed) + parseInt(1000); //Ȃ̂Œ
		
		var dis_1sec = parseInt((start_left - end_left) / (speed_temp / 1000));
		var right_thru_sec1 = ((start_left - nico_w) / dis_1sec);
		var right_thru_sec2 = ((start_left - nico_w + comment_width) / dis_1sec);
		var left_thru_sec1 = (start_left / dis_1sec);
		var left_thru_sec2 = speed_temp / 1000;
		
		var show_top_pos = n.top_pos;
		var show_ok = 0;
		var comment_line_height = (parseInt(n.env.font_size) * comment_line_height_per);
		
		for (var i2=0 ; i2<row_right.length ; i2++){
  			if (row_right[i2] <= right_thru_sec1 && row_left[i2] <= left_thru_sec1) {
  				row_right[i2] = right_thru_sec2;
  				row_left[i2] = left_thru_sec2;
  				show_top_pos = parseInt(player_top_margin) + parseInt(i2 * comment_line_height);
				if (parseInt(show_top_pos) + parseInt(n.env.font_size) > (nico_h - player_bottom_margin)) { 
					//[𒴂
					if (comment_show_half > 0) {
						//ő剽s\ł̂
						var row_max = parseInt((nico_h -player_top_margin -player_bottom_margin) / parseInt(comment_line_height));
						if (i2 < (row_max * 2 - 1)) {
							//0.5s\
							show_top_pos = parseInt(comment_line_height / 2) + parseInt(player_top_margin) + parseInt((i2 - row_max) * comment_line_height);
							show_ok = 1;
						}
					}
				} else {
	  				show_ok = 1;
				}
				if (comment_max_row > 0) {
					if ( show_top_pos > parseInt(player_top_margin) + parseInt((comment_max_row - 1) * comment_line_height) ) {
						//ő\s𒴂ĂΕ\Ȃ
						show_ok = 0;
					}
				}
				
  				break;
  			}
		}
		
		if (show_ok > 0) {
		
			//color
			var temp_color = this.env.color
			if (comment_color_on == 1) {
				temp_color = comment_colors[(Math.floor(Math.random() * comment_colors.length))];
			}
		
			var cmid = "cm" + i + "";
			var com_obj = $("<div id='" + cmid + "' style='left:" + start_left + "px; position:absolute;top:" + show_top_pos + "px;color:"+temp_color+";font-size:"+n.env.font_size+";font-weight:bold;text-shadow: black 2px 1px 0px;width:100%;z-index:99999;cursor:default;white-space: nowrap;'>" + comment_str + "</div>");
		
			$("#nicoscreen").append(com_obj);
		
			(function(that){
				if (animation_method == 0) {
					//jQuery animate
					var tmp_cmid = cmid;
					com_obj.animate({
						left: end_left
					}, {
						duration: speed_temp,
						easing: 'linear', 
						complete: function(){
							var elm_id = "#" + tmp_cmid;
							$("#nicoscreen").remove(elm_id);
							that.top_pos = 10;
						}
					});
				} else {
					//CSS3 transition
					var tmp_cmid = cmid;
					com_obj.css("transition", "left " + speed_temp + "ms linear 0");
					com_obj.css("left");
					com_obj.css("left", end_left + "px");
                	setTimeout(function () {
							var elm_id = "#" + tmp_cmid;
							$("#nicoscreen").remove(elm_id);
							that.top_pos = 10;
    	            }, speed_temp);
				}
			})(this);
		
		}
	},
	
	add:function(str){
		this.draw(str);
	}
	
};

var nicoscreen = nicoscreenobj(r9.NicoScreen);
